// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "MeshRenderer.hpp"
#include "MeshHost.hpp"
#include "scene/SceneItem.hpp"

using namespace Dawn;

MeshRenderer::MeshRenderer(SceneItem *item) : SceneItemComponent(item) {
}

std::vector<SceneItemComponent*> MeshRenderer::getDependencies() {
  return std::vector<SceneItemComponent*>{
    this->item->getComponent<MeshHost>()
  };
}

void MeshRenderer::onStart() {
  SceneItemComponent::onStart();

  if(mesh == nullptr) {
    auto host = this->item->getComponent<MeshHost>();
    if(host != nullptr) this->mesh = &host->mesh;
  }
}