// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "TiledSprite.hpp"
#include "scene/SceneItem.hpp"

using namespace Dawn;

TiledSprite::TiledSprite(SceneItem *item) : SceneItemComponent(item) {

}

std::vector<SceneItemComponent*> TiledSprite::getDependencies() {
  this->renderer = this->item->getComponent<MeshRenderer>();
  this->host = this->item->getComponent<MeshHost>();

  return std::vector<SceneItemComponent*>{
    this->renderer,
    this->host
  };
}

void TiledSprite::onStart() {
  SceneItemComponent::onStart();

  assertNotNull(this->host);

  QuadMesh::initQuadMesh(&this->host->mesh, 
    glm::vec2(0, 0), glm::vec2(0, 0),
    glm::vec2(1, 1), glm::vec2(0.125f, 0.125f),
    0
  );
}