// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "scene/components/display/MeshRenderer.hpp"
#include "scene/components/display/MeshHost.hpp"
#include "display/mesh/QuadMesh.hpp"
#include "display/Tileset.hpp"

namespace Dawn {
  class TiledSprite : public SceneItemComponent {
    protected:
      MeshRenderer *renderer;
      MeshHost *host;

    public:
      TiledSprite(SceneItem *item);

      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}